/*
 * readanysf~  external for pd. 
 * 
 * Copyright (C) 2003 August Black
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * ReadMadUrl.h  || much code studied from Andy Lo-A-Foe <www.alsaplayer.org>
 * and shoutamp~ by Olaf Matthes <olaf.matthes@gmx.de>
 */

#ifndef _READMADURL_H_
#define _READMADURL_H_

#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <inttypes.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>

#include <pthread.h>

#include "Fifo.h"
//#include <flext.h>

#define SOCKET_ERROR -1


extern "C" { 	
#include <mad.h>
}

//#include "xing.h"
#include "Readsf.h"



#define STREAM_FIFOSIZE	(32 * 1152)
#define STREAM_BUFFERSIZE (4 * 1152)
#define SOCKET_READSIZE	1152/4
#define FRAME_RESERVE	2000



class ReadMadUrl : public Readsf {
  //FLEXT_HEADER(simple,flext_base)
    
 protected:


 private:
  //flext_base::FLEXT_THREAD(fill_infifo)

  pthread_mutex_t x_mutex;
  pthread_cond_t x_condition;
  pthread_t x_childthread;
  
  bool quit;

  int mad_fd;
  unsigned char mad_map[STREAM_BUFFERSIZE];
  long map_offset;
  int bytes_avail;

  struct mad_synth  synth; 
  struct mad_stream stream;
  struct mad_frame  frame;

  char hostname[1024];
  char mountpoint[1024];
  int port;

  int mad_init;
  ssize_t offset;
  ssize_t filesize;
  int bitrate;
  int samplesperframe;
  long samplestotal;
  long time;
  int seekable;
  int nr_frames;

  Fifo *madfifo;


  //void *fill_infifo(void *leer);
  bool fill_buffer( );
  int mad_frame_seek( int frame );
  ssize_t find_initial_frame(uint8_t *buf, int size);
  void seek_bytes(long byte_offset);



  void socket_disconnect(int fd);
  int strip_shout_header(char *head, int n);
  int strip_ice_header(char *head, int n);

  void set_url(const char *url);
  //int receive(int fd, unsigned char *rcvbuffer, int size);
  
 public:
  ReadMadUrl();
  virtual ~ReadMadUrl();
  virtual bool Initialize(const char *file);
  virtual int Decode(float *buffer, int size);
  virtual bool Rewind();

  int socket_connect(char *hostname, char *mountpoint, int portno);
  
  pthread_mutex_t *get_mutex() { return &x_mutex;}
  pthread_cond_t *get_condition(){ return &x_condition;}
  int get_fd() { return mad_fd;}
  void set_fd(int tmpfd) { mad_fd = tmpfd;}


  char * get_hostname() { return hostname;}
  char * get_mountpoint() { return mountpoint;}
  int get_port() { return port;}
  bool get_quit() { return quit;}
  Fifo * get_fifo() { return madfifo;}
};		

#endif
